VERSION 5.00
Begin VB.Form Decipher 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Decipher"
   ClientHeight    =   5490
   ClientLeft      =   150
   ClientTop       =   720
   ClientWidth     =   6975
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5490
   ScaleWidth      =   6975
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame frame_frequency 
      Caption         =   "Frequency Analysis"
      Height          =   1335
      Left            =   120
      TabIndex        =   12
      Top             =   3480
      Visible         =   0   'False
      Width           =   2775
      Begin VB.CommandButton button_change 
         Caption         =   "Change &Manually"
         Height          =   375
         Left            =   240
         TabIndex        =   14
         Top             =   840
         Width           =   2295
      End
      Begin VB.CommandButton button_analyse 
         Caption         =   "&Analyse"
         Height          =   375
         Left            =   240
         TabIndex        =   13
         Top             =   360
         Width           =   2295
      End
   End
   Begin VB.CommandButton button_exit 
      Caption         =   "E&xit"
      Height          =   495
      Left            =   120
      TabIndex        =   11
      Top             =   4920
      Width           =   2775
   End
   Begin VB.Frame frame_caesar 
      Caption         =   "Caesar Shift"
      Height          =   1335
      Left            =   120
      TabIndex        =   6
      Top             =   3480
      Width           =   2775
      Begin VB.CheckBox check_reverse 
         Caption         =   "Check1"
         Height          =   255
         Left            =   840
         TabIndex        =   16
         Top             =   900
         Width           =   255
      End
      Begin VB.CommandButton button_decrease 
         Caption         =   "&Decrease"
         Height          =   375
         Left            =   1200
         TabIndex        =   10
         Top             =   360
         Width           =   1455
      End
      Begin VB.CommandButton button_increase 
         Caption         =   "&Increase"
         Height          =   375
         Left            =   1200
         TabIndex        =   9
         Top             =   840
         Width           =   1455
      End
      Begin VB.Label Label2 
         Caption         =   "Reverse"
         Height          =   255
         Left            =   120
         TabIndex        =   17
         Top             =   900
         Width           =   615
      End
      Begin VB.Label Label1 
         Caption         =   "Shift:"
         Height          =   255
         Left            =   120
         TabIndex        =   8
         Top             =   420
         Width           =   375
      End
      Begin VB.Label label_shift 
         Caption         =   "0"
         Height          =   255
         Left            =   600
         TabIndex        =   7
         Top             =   420
         Width           =   255
      End
   End
   Begin VB.Frame type 
      Caption         =   "Type"
      Height          =   975
      Left            =   120
      TabIndex        =   3
      Top             =   2400
      Width           =   2775
      Begin VB.OptionButton option_frequency 
         Caption         =   "F&requency Analysis"
         Height          =   255
         Left            =   360
         TabIndex        =   5
         Top             =   600
         Width           =   1935
      End
      Begin VB.OptionButton option_cipher 
         Caption         =   "&Caesar Shift Cipher"
         Height          =   255
         Left            =   360
         TabIndex        =   4
         Top             =   240
         Value           =   -1  'True
         Width           =   1935
      End
   End
   Begin VB.Frame plaintext 
      Caption         =   "Plaintext"
      Height          =   3015
      Left            =   3000
      TabIndex        =   1
      Top             =   2400
      Width           =   3855
      Begin VB.TextBox text_plain 
         Height          =   2655
         Left            =   120
         MultiLine       =   -1  'True
         TabIndex        =   2
         Top             =   240
         Width           =   3615
      End
   End
   Begin VB.Frame Ciphertext 
      Caption         =   "Ciphertext"
      Height          =   2175
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   6735
      Begin VB.TextBox text_cipher 
         Height          =   1815
         Left            =   120
         MultiLine       =   -1  'True
         TabIndex        =   15
         Top             =   240
         Width           =   6495
      End
   End
   Begin VB.Menu menu_file 
      Caption         =   "&File"
      Begin VB.Menu menu_exit 
         Caption         =   "&Exit"
      End
   End
   Begin VB.Menu menu_help 
      Caption         =   "&Help"
      Begin VB.Menu menu_about 
         Caption         =   "&About"
      End
   End
End
Attribute VB_Name = "Decipher"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Public offset As Integer
Dim alphabet(26), Frequency(26), English(26) As Integer
Dim analysed_before As Boolean

Private Sub button_analyse_Click()

Dim pos As Integer
Dim do_again As Integer

do_again = vbYes

If analysed_before Then do_again = MsgBox("You have analysed the frequencies before.  This will reset any changes you have made to the cipher alphabet.  Do you wish to continue?", vbYesNo, "Analysis Already Done")

If do_again = vbYes Then

    If Len(text_cipher.Text) <> 0 Then
        Call analyse(text_cipher.Text)
        analysed_before = True
    End If

    For pos = 0 To 25
        frmFrequency.letter(pos).Caption = Chr$(pos + 65)
        frmFrequency.English(pos).Caption = Str$(English(pos + 1))
        frmFrequency.cipher(pos).Caption = Str$(Frequency(pos + 1))
    Next

    Call match
    Call frequency_results

End If

frmFrequency.Refresh
frmFrequency.Show

End Sub

Private Sub button_change_Click()

Dim pos As Integer

For pos = 0 To 25
    frmAlphabet.letter(pos).Caption = Chr$(pos + 65)
    frmAlphabet.text_cipher(pos).Text = Chr$((alphabet(pos + 1)) + 96)
Next

frmAlphabet.Refresh
frmAlphabet.Show vbModal, Me

End Sub

Private Sub button_decrease_Click()

If offset = 0 Then
    offset = 25
Else
    offset = offset - 1
End If

label_shift.Caption = Str$(offset)

text_plain.Text = caesar(text_cipher.Text)

End Sub

Private Sub button_exit_Click()

End

End Sub



Private Sub button_increase_Click()

If offset = 25 Then
    offset = 0
Else
    offset = offset + 1
End If

label_shift.Caption = Str$(offset)

text_plain.Text = caesar(text_cipher.Text)

End Sub

Private Sub check_reverse_Click()

text_plain.Text = caesar(text_cipher.Text)

End Sub

Private Sub Form_Load()

analysed_before = False

English(1) = 82
English(2) = 15
English(3) = 28
English(4) = 43
English(5) = 127
English(6) = 22
English(7) = 20
English(8) = 61
English(9) = 70
English(10) = 2
English(11) = 8
English(12) = 40
English(13) = 24
English(14) = 67
English(15) = 75
English(16) = 19
English(17) = 1
English(18) = 6
English(19) = 63
English(20) = 91
English(21) = 28
English(22) = 10
English(23) = 24
English(24) = 2
English(25) = 20
English(26) = 1

End Sub

Private Sub option_cipher_Click()

frame_caesar.Visible = True
frame_frequency.Visible = False

End Sub

Private Sub option_frequency_Click()

frame_frequency.Visible = True
frame_caesar.Visible = False

End Sub

Private Function caesar(cipher As String)

Dim pos, char As Integer
Dim intermediate As String

For pos = 1 To Len(cipher)
    char = Asc(Mid$(cipher, pos, 1))
    If char <> 32 Then
        If check_reverse Then
            char = (25 - (((char + offset) - 65) Mod 26)) + 97
        Else
            char = (((char + offset) - 65) Mod 26) + 97
        End If
    End If
    intermediate = intermediate + Chr$(char)
Next

caesar = intermediate

End Function
Private Sub analyse(cipher As String)

Dim pos, char As Integer
Dim int_value As Single

For pos = 1 To 26
    Frequency(pos) = 0
Next

For pos = 1 To Len(cipher)
    char = Asc(Mid$(cipher, pos, 1)) - 64
    If char > 0 Then Frequency(char) = Frequency(char) + 1
Next

End Sub
Public Sub adjust()

Dim letter As Integer

For letter = 1 To 26
    alphabet(letter) = Asc(frmAlphabet.text_cipher(letter - 1).Text) - 96
Next

Call frequency_results

End Sub



Private Sub text_cipher_LostFocus()

Dim intermediate As String
Dim pos, char As Integer

intermediate = ""

For pos = 1 To Len(text_cipher.Text)
    char = Asc(Mid$(text_cipher.Text, pos, 1))
    If char > 64 And char < 92 Then
        intermediate = intermediate + Chr$(char)
    Else
        If char > 96 And char < 123 Then
            intermediate = intermediate + Chr$(char - 32)
        Else
            intermediate = intermediate + " "
        End If
    End If
Next

text_cipher.Text = intermediate

If option_cipher = True Then
    
    text_plain.Text = caesar(text_cipher.Text)

End If

End Sub

Private Sub match()

Dim rank_english(26), rank_cipher(26), temp_english(26), temp_cipher(26), letter, pass, highest, value As Integer

For pass = 1 To 26
    temp_english(pass) = English(pass)
    temp_cipher(pass) = Frequency(pass)
Next

'Rank frequencies in standard English
For pass = 1 To 26
    highest = 0
    For letter = 1 To 26
        If temp_english(letter) >= highest Then
            highest = temp_english(letter)
            value = letter
        End If
    Next
    
    rank_english(pass) = value
    temp_english(value) = -1
Next

'Rank frequencies in ciphertext
For pass = 1 To 26
    highest = 0
    For letter = 1 To 26
        If temp_cipher(letter) >= highest Then
            highest = temp_cipher(letter)
            value = letter
        End If
    Next
    
    rank_cipher(pass) = value
    temp_cipher(value) = -1
Next

'Build cipher alphabet
For letter = 1 To 26
    pass = 1
    While rank_cipher(pass) <> letter
    pass = pass + 1
    Wend
    alphabet(letter) = rank_english(pass)
Next

End Sub

Private Sub frequency_results()

Dim pos, char, new_char As Integer
Dim intermediate As String

'For pos = 1 To Len(text_cipher.Text)
'    char = Asc(Mid$(text_cipher.Text, pos, 1)) - 64
'    If char > 0 Then
'        new_char = 1
'        While alphabet(new_char) <> char
'            new_char = new_char + 1
'        Wend
'        new_char = alphabet(new_char)
'        intermediate = intermediate + Chr$(new_char + 96)
'    Else
'        intermediate = intermediate + " "
'    End If
'Next

For pos = 1 To Len(text_cipher.Text)
    char = Asc(Mid$(text_cipher.Text, pos, 1)) - 64
    If char < 1 Then
        new_char = -64
    Else
        new_char = alphabet(char)
    End If
    intermediate = intermediate + Chr$(new_char + 96)
Next

text_plain.Text = intermediate

End Sub
